package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleGuardNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleGuardNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleGuardNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleGuardNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleGuardNode build(long ptr) {
		return new ISLScheduleGuardNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleGuardNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_guard_get_guard 
	 * 
	 * @generated
	**/
	public ISLSet getGuard() {
		/*** PROTECTED REGION ID(isl_schedule_node_guard_get_guard) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSet.build(ISLNative.isl_schedule_node_guard_get_guard(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleGuardNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleGuardNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
